Subject: bug#52973: Adding a few context-menu-mode commands

From: Eli Zaretskii <[email-masked]>
Date: Tue, 04 Jan 2022 14:26:59 +0200

> From: Juri Linkov <[email-masked]>
> Cc: Eli Zaretskii <[email-masked]>,  [email-masked]
> Date: Mon, 03 Jan 2022 23:17:18 +0200
> 
> >>> > Maybe I'm missing something, but I don't see the actual integration
> >>> > with context-menu-mode?
> >>>
> >>> Each commit adds a function that can be added to context-menu-functions.
> >>
> >> That was my guess, but without having those additions, not even as a
> >> user option, or (better) automagically when context-menu-mode is
> >> turned on, those functions are just dead ballast, aren't they?
> >
> > From my understanding of bug#50552, this was preferred.
> 
> bug#50552 proposed to add to every package such lines:
> 
>   (custom-add-choice 'context-menu-functions
>                      '(function-item :tag "Dictionary menu" context-menu-dictionary))
> 
> but 'custom-add-choice' fails on the current structure of
> 'context-menu-functions', so either a new function 'custom-add-repeat-choice'
> should be created, or better would be to improve the existing
> 'custom-add-choice' to handle the choices inside 'repeat'.

How about add-context-menu-items, or something to that effect?  We are
talking about quite a different feature to "add", IMO, so a new API
would be better, I think.  And it doesn't have to have anything to do
with custom.el.

But in any case, we need to do this soon, because adding functions
that are not used unless the user plays with hooks is not clean,
definitely not for a feature such as this one, because it's supposed
to be very easy, ideally seamless, to activate.  Otherwise it would be
against the raisons d'être of the feature.